//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 25-1
//
// Asks user for the size of each room in a house. The program then
// calculates and outputs the volume of the house in cubic feet.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

#include <ios.h>

typedef int32 inches;
typedef int32 cubic_feet;

#define MAX_ROOMS 10

typedef
   struct {
      inches hieght;
      int8 room_count;
      struct {
         inches width;
         inches length;
      } rooms[MAX_ROOMS];
   } house_type;
   
int16 get_dimension(char* for_what) {
   int16 feet_in, inches_in;
   cout << "Enter room " << for_what << " in feet, space, inches: ";
   cin >> feet_in >> inches_in;
   return (feet_in*12)+inches_in;
}

void input_data(house_type* house) {
   house->hieght=get_dimension("hieght");
   cout << endl << "Enter data for each room, 0 0 when one." << endl;
   house->room_count=0;
   do {
      cout << endl;
      house->rooms[house->room_count].width=get_dimension("width");
      if(house->rooms[house->room_count].width==0)
         break;
      house->rooms[house->room_count].length=get_dimension("length");
      house->room_count++;
   } while (house->room_count<MAX_ROOMS);
}

cubic_feet calculate_volume(house_type* house) {
   int32 cubic_inches=0;
   for(int i=0; i<house->room_count; i++){
      cubic_inches+=(int32)(house->hieght)*
      ((house->rooms[i].width)*(house->rooms[i].length));
      cout << "hight: " << house->hieght/12 << "  width: " << 
      house->rooms[i].width/12 << "  length: " << house->rooms[i].length/12 << endl;
      cout << "\n" << cubic_inches/(12*12*12) << "\n" << endl;
   }
   return cubic_inches/(12*12*12);
}

void main(void) {
   house_type house;
   do {
      input_data(&house);
      cout << "Volume of air in house = " << calculate_volume(&house)
      << " cubic feet" << endl << endl;
   } while(TRUE);
}
